
package empty;

import java.util.*;
import java.applet.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.sql.*;

import snap.*;

/** Example of an empty Snapplet.
  * @author Nathan Conklin - nathan@conklinfamily.net
  * @author Chris North - north@cs.vt.edu
  */
public class EmptySnapplet extends Snapplet
implements Snapable, ActionListener
{

private JTextArea text = new JTextArea();
private JPanel panel = new JPanel(new BorderLayout());
private String APPLET_TYPE = "Empty";
private JButton button = new JButton("Fire Empty Event");

/** Returns an empty Enumeration of SnapEvents */
public Enumeration getSupportedActions()
{
	Vector v = new Vector();
	v.add("Select");
	return v.elements();
}

/** Implementation of Snapable's load() method */
public void load(ResultSet rs, String primaryKeyColumnName)
{
	String eventText;
	eventText =
		"load(ResultSet rs, String primaryKeyColumnName) called\n" +
		"primaryKeyColumnName: " + primaryKeyColumnName + "\n" +
		"Data: \n";

	try
	{
		int columnCount = rs.getMetaData().getColumnCount();
		while (rs.next())
		{
			String line = "";
			for (int i = 0; i < columnCount; i++ )
			{
				line += rs.getString(i+1);
				if (i < columnCount - 1)
					line += ", ";
			}
			eventText += line + "\n";
		}
	}
	catch(SQLException e)
	{
		eventText += e.toString();
	}

	text.setText(eventText);
}

/** Returns the component's Icon */
public Icon getIcon()
{
	return null;
}

/** Returns the Snapplet's type info */
public String getAppletInfo()
{
	return APPLET_TYPE;
}

/** Executes the appropriate action for the SnapEvent.
  * Empty does not support an SnapEvent. */
public void performSnapEvent(SnapEvent e)
{
	String eventText;
	eventText = "performSnapEvent(SnapEvent e) called\n" +
		"eventType: " + e.getEventType() + "\n" +
		"keys: \n";
	Enumeration enum = e.getKeys().elements();
	while(enum.hasMoreElements())
		eventText += enum.nextElement().toString() + "\n";

	text.setText(eventText);
}

/** Fires an empty SnapEvent */
public void actionPerformed(ActionEvent e)
{
	String eventText = "Firing an empty SnapEvent";
	fireSnapEvent(new SnapEvent(this, "Select", new Vector()));
	text.setText(eventText);
}

/** Applet's init method to create the content pane */
public void init()
{
	text.setText("Empty Snapplet Init() called");
	JScrollPane scroll = new JScrollPane(text);
	panel.add(scroll, BorderLayout.CENTER);

	button.addActionListener(this);
	panel.add(button, BorderLayout.SOUTH);
    setContentPane(panel);
}


}
