
package scatterplot;

import java.awt.*;
import java.util.Enumeration;
import java.util.Vector;
import snap.*;

class PlotCanvas extends Canvas
{
	ScatterPlot scatter=null;
    int variableCount;
    int dataCount;
    int width;
    int height;

    public PlotCanvas(double ad[], double ad1[], String as[], int i, int j)
    {
       enterData(ad, ad1, as, i, j);
    }

    public PlotCanvas(String as[], int i, boolean flag, int j, boolean
    			flag1, boolean flag2, boolean flag3)
    {
        box = 3;
        names = as;
        namemark = i;
        label = flag;
        variableCount = j;
        rect = flag1;
        lside = flag2;
        bottom = flag3;
        Splot = false;
        newmark = false;
    }

    void setData(double ad[], double ad1[], String as[], int i, int j)
    {
        enterData(ad, ad1, as, i, j);
	resetPlot();
    }

    void enterData(double ad[], double ad1[], String as[], int i, int j)
    {
        box = 3;
        xd = ad;
        yd = ad1;
        pd = as;
        variableCount = i;
        dataCount = j;
        marked = new boolean[dataCount];
        for(int k = 0; k < dataCount; k++)
            marked[k] = false;
        Splot = true;
        newmark = false;
        mDrag = false;
    }

    void DrawImage()
    {
	//System.out.println("DrawImage()");
        Offscreen = createImage(width, height);
        Offgraph = Offscreen.getGraphics();
        //Offgraph.setColor(Color.white);
        Offgraph.setColor(Color.white);
        Offgraph.fillRect(0, 0, width, height);
        if(Splot)
        {
            //Offgraph.setColor(Color.lightGray);
            //Offgraph.drawRect(0, 0, width - 1, height - 1);
            Offgraph.setColor(Color.black);
            xi = Transform.adtoaipixel(xd, dataCount, width);
            yi = Transform.adtoaipixel(yd, dataCount, height);
            int ai[] = Transform.getUnMarked(marked);
            for(int i = 0; i < ai.length; i++)
            {
                int j1 = xi[ai[i]] + 3;
                int i2 = height - 1 - yi[ai[i]] - 6;
                Offgraph.drawOval(j1, i2, 8, 8);
            }

            Offgraph.setColor(Color.red);
            ai = Transform.getMarked(marked);
            for(int k1 = 0; k1 < ai.length; k1++)
            {
                int j2 = xi[ai[k1]] + 3;
                int i3 = height - 1 - yi[ai[k1]] - 6;
                Offgraph.fillOval(j2, i3, 8, 8);
            }

            matrix = new Vector[width][height];
            for(int k2 = 0; k2 < dataCount; k2++)
            {
	        Vector locationVector;
	        locationVector = matrix[xi[k2] + 3][height - 1 - yi[k2] - 6]; 
                if(locationVector == null)
                    locationVector = new Vector();
                Integer integer = new Integer(k2);
                locationVector.addElement(integer);
            }

            return;
        }
	/*
        Offgraph.setColor(Color.lightGray);
        if(rect)
            Offgraph.drawRect(0, 0, width - 1, height - 1);
        if(bottom)
            Offgraph.drawLine(0, height - 1, width - 1, height - 1);
        if(lside)
            Offgraph.drawLine(0, 0, 0, height - 1);
	*/
        if(label)
        {
            Offgraph.setColor(Color.blue);
            Offgraph.setFont(new Font("TimesRoman", 3, 36));
            String s = "";
            int j = 0;
            for(int l1 = 0; l1 < variableCount; l1++)
            {
                int l2 = Offgraph.getFontMetrics().stringWidth(names[l1]);
                if(l2 >= j)
                {
                    j = l2;
                    s = names[l1];
                }
            }

            boolean flag = true;
            for(int j3 = 0; j3 < 36; j3++)
            {
                Offgraph.setFont(new Font("TimesRoman", 3, 36 - j3));
                int k = Offgraph.getFontMetrics().stringWidth(s);
                if(flag && k < width - 6)
                {
                    int l =
					Offgraph.getFontMetrics().stringWidth(names[namemark]);
                    Offgraph.drawString(names[namemark],
						(width - l) / 2, height / 2 + 10);
                    flag = false;
                }
            }

            if(flag)
            {
                int i1 =
					Offgraph.getFontMetrics().stringWidth(names[namemark]);
                Offgraph.drawString(names[namemark], (width - i1) / 2,
					height/ 2 + 10);
            }
        }
    }

    public Dimension minimumSize()
    {
        return preferredSize();
    }

    public Dimension preferredSize()
    {
        return new Dimension(200, 200);
    }

    public void paint(Graphics g)
    {
	//System.out.println("paint(Graphics g)");
        Dimension dimension = getSize();

	//System.out.println("getSize() - " + getSize());
	//System.out.println("getMaximumSize() - " + getMaximumSize());
	//System.out.println("getPreferredSize() - " + getPreferredSize());

        if(dimension.width != width || dimension.height != height)
        {
            width = dimension.width;
            height = dimension.height;
            DrawImage();
        }
        g.drawImage(Offscreen, 0, 0, this);
        if(mDrag && Splot)
        {
            if(a <= c)
                if(b <= d)
                {
                    g.drawRect(a, b, c - a, d - b);
                    return;
                } else
                {
                    g.drawRect(a, d, c - a, b - d);
                    return;
                }
            if(b <= d)
            {
                g.drawRect(c, b, a - c, d - b);
                return;
            }
            g.drawRect(c, d, a - c, b - d);
        }
    }

    public void update(Graphics g)
    {
        paint(g);
    }

    public boolean mouseMove(Event event, int i, int j)
    {
        a = i;
        b = j;
        checkstatus = true;
        if(Splot)
        {
            int ai[] = new int[dataCount];
            int k = 0;
            if((2 * box + 1) * (2 * box + 1) <= dataCount)
            {
                int l;
                if(a < box)
                    l = 0;
                else
                    l = a - box;
                int j1;
                if(a > width - 1 - box)
                    j1 = width - 1;
                else
                    j1 = a + box;
                int l1;
                if(b < box)
                    l1 = 0;
                else
                    l1 = b - box;
                int i2;
                if(b > height - 1 - box)
                    i2 = height - 1;
                else
                    i2 = b + box;
                for(int j2 = l; j2 <= j1; j2++)
                {
                    for(int k2 = l1; k2 <= i2; k2++)
                        if(matrix[j2][k2] != null)
                        {
                            Enumeration e = matrix[j2][k2].elements();
                            while(e.hasMoreElements())
                            {
                                Integer integer =
				   Integer.valueOf(e.nextElement().toString());
                                int l2 = integer.intValue();
                                ai[k] = l2;
                                k++;
                            }

                        }

                }

            } else
            {
				if(xi != null)
				{
					for(int i1 = 0; i1 < dataCount; i1++)
                    if(	a >= (xi[i1] + 3) - box
						&& a <= xi[i1] + 3 + box
						&& b >= height - 1 - yi[i1] - 6 - box
						&& b <= (height - 1 - yi[i1] - 6) + box)
                    {
                        ai[k] = i1;
                        k++;
                    }
				}
            }
            if(k > 0)
            {
                Vector vector = new Vector();
                for(int k1 = 0; k1 < k; k1++)
                    vector.addElement(pd[ai[k1]]);

                tmpstatus = vector.toString();
            } else
            {
                tmpstatus = "";
            }
        } else
        if(label)
            tmpstatus = names[namemark];
        else
            tmpstatus = "";
        return false;
    }

    public boolean mouseDown(Event event, int i, int j)
    {
        if(Splot)
        {
            a = i;
            b = j;
            c = a;
            d = b;
        }
        return true;
    }

    public boolean mouseDrag(Event event, int i, int j)
    {
        if(Splot)
        {
            c = i;
            d = j;
            mDrag = true;
            repaint();
        }
        return true;
    }

    void assignScatterplot(ScatterPlot scatter)
    {
    //System.out.println("assigning scatter");
    this.scatter=scatter;
    }

    public boolean mouseUp(Event event, int i, int j)
    {
        /* Added by Nathan */
        if(event.controlDown())
		{
			scatter.clearPlot();
			return true;
		}
	/* **************** */
        mDrag = false;
        if(Splot)
        {
            if(a <= i)
            {
                c = i;
            } else
            {
                c = a;
                a = i;
            }
            if(b <= j)
            {
                d = j;
            } else
            {
                d = b;
                b = j;
            }
            if(a < box)
                a = 0;
            else
                a = a - box;
            if(b < box)
                b = 0;
            else
                b = b - box;
            if(c > width - 1 - box)
                c = width - 1;
            else
                c = c + box;
            if(d > height - 1 - box)
                d = height - 1;
            else
                d = d + box;
            if((c - a) * (d - b) <= dataCount)
            {
                for(int k = a; k <= c; k++)
                {
                    for(int i1 = b; i1 <= d; i1++)
                        if(matrix[k][i1] != null)
                        {
			    Enumeration e = matrix[k][i1].elements();
			    while(e.hasMoreElements())
                            {
                                Integer integer = Integer.valueOf(
				    e.nextElement().toString());
                                int j1 = integer.intValue();
                                marked[j1] = true;
                                newmark = true;
                            }

                        }

                }

            } else
            {
                for(int l = 0; l < dataCount; l++)
                    if(a <= xi[l] + 3 && c >= xi[l] + 3 && b <= height
		    - 1 - yi[l] - 6 && d >= height - 1 - yi[l] - 6)
                    {
                        marked[l] = true;
                        newmark = true;
                    }

            }
            if(newmark)
            {
                return false;
            } else
            {
                repaint();
                return true;
            }
        } else
        {
            return true;
        }
    }

    public boolean mouseExit(Event event, int i, int j)
    {
        checkstatus = false;
        return true;
    }

    public boolean getnewmark()
    {
        return newmark;
    }

    public boolean[] getmarked()
    {
        return marked;
    }

    public String getStatus()
    {
        return tmpstatus;
    }

    public boolean getCheckstatus()
    {
        return checkstatus;
    }

/************************/


    /****************************/
	
	/*****************************/
	
    public void highlight(boolean aflag[])
    {
     
        if(Splot)
        {
            Offgraph.setColor(Color.red);
            for(int i = 0; i < dataCount; i++)
            {
                marked[i] = aflag[i];
                if(aflag[i])
                    Offgraph.fillOval(
						xi[i] + 3, height - 1 - yi[i] - 6, 8, 8);
            }

            newmark = false;
            repaint();
        }
    }
  

    public void resetPlot()
    {
	//System.out.println("resetPlot()");
        for(int i = 0; i < dataCount; i++)
        marked[i] = false;
        DrawImage();
        repaint();
    }

    int box;
    int a;
    int b;
    int c;
    int d;
    int namemark;
    String tmpstatus;
    double xd[];
    double yd[];
    int xi[];
    int yi[];
    String pd[];
    String names[];
    boolean marked[];
    boolean Splot;
    boolean label;
    boolean newmark;
    boolean mDrag;
    boolean checkstatus;
    boolean rect;
    boolean lside;
    boolean bottom;
    Vector matrix[][];
    Image Offscreen;
    Graphics Offgraph;

};
