
package scatterplot;

import snap.*;

import java.applet.*;
import java.awt.*;
import java.util.*;
import javax.swing.*;
import java.sql.*;
import java.net.URL;

public class ScatterPlot extends Snapplet
implements Snapable
{

int variableCount;
int dataCount;
String sdata[];
String piddata[];
double ddata[][];
boolean marked[];
boolean oldmark[];
PlotCanvas Splot;
Text pointid;
double ad[];
double ad1[];
Object pkdata[];

String pkName=null;//name of the primary key
Panel menu = new Panel();
Label xLabel = new Label("X Var:");
Label yLabel = new Label("Y Var:");
String xVariable, yVariable = "";
Choice xChoice = new Choice();
Choice yChoice = new Choice();

int rowCount;
int columnCount;
String[] columnNames;
Object[][] data = null;
String SELECT_EVENT_ID = "Select";
String APPLET_TYPE = "ScatterPlot 0.1";

public String getAppletInfo()
{
	return APPLET_TYPE;
}

public Enumeration getSupportedActions()
{
	Vector v = new Vector();
	v.add(SELECT_EVENT_ID);
	return v.elements();
}

public void load(ResultSet rs, String primaryKeyColumnName)
{

	pkName=primaryKeyColumnName;//assigns primary key
	if(rs != null)
	{
	   ResultSetMetaData rsmd;
	   try
	   {
			int i;
			rsmd = rs.getMetaData();

			// Find the number of columns
			columnCount = rsmd.getColumnCount();

			// Initialize the column header array
			columnNames = new String[columnCount];
			for(i=0; i < columnCount; i++)
			{
			   columnNames[i] = rsmd.getColumnName(i+1);
			}

			// Find the number of rows
			rowCount = 0;
			while(rs.next())
			{
			   rowCount++;
			}

			// Initialize the data array
			data = new Object[rowCount][columnCount];
			marked = new boolean[rowCount];
			oldmark = new boolean[rowCount];

			rs.first();
			for(i = 0; i < rowCount; i++)
			{
				for(int j=0; j < columnCount;j++)
				{
					data[i][j] = rs.getObject(j+1);
				}
				rs.next();
			}
			setVariableChoices(data);
			variableChange();
	   }
	   catch(SQLException e)
	   {
		   System.err.println(e.toString());
		   return;
	   }
	}
}
/*****************************GETCOLUMN******************************/

/** Returns the component's Icon */
public Icon getIcon()
{
	Icon icon = null;
	try
	{
		String base = getCodeBase().toString();
		String iconURL = base + "scatterplot/scatterplot.jpg";
		icon = 	new ImageIcon(new URL(iconURL));
	}
	catch(Exception e)
	{
		System.err.println("TableSorterDemo: " + 
			"Unable to create an icon: " + e.toString());
	}
	return icon;
}

public void performSnapEvent(SnapEvent e)
{
    Vector selectedObjects = e.getKeys();

	System.out.println( " The objects selected are " + selectedObjects );

    if (selectedObjects == null || selectedObjects.size()==0)
    {
        //System.out.println("reset  ");
        Splot.resetPlot();
    }
    else
    {
        Splot.resetPlot();
		//Convert Vector to boolean
		boolean []marked=new boolean[ad.length];
		for (int i=0;i<ad.length;i++)
		{
			marked[i]=false;
		}
		for (int i=0;i<selectedObjects.size() ;i++ )
		{
			Object temp = selectedObjects.elementAt(i);
			for (int j=0;j<pkdata.length ;j++ )
			{
				if (pkdata[j].equals(temp))
				{
					marked[j]=true;
					break;
				}	
			}
		}
		highlight(marked);
	}//else ends
    
}

// -------------------------------------------------------

/***********************************************************************/

/* setVariableChoices(ResultSet) - sets the menu choices for the user
 * to select the x and y variables.
 */
protected void setVariableChoices(Object[][] data)
{
    int i;

    xChoice.removeAll();
    yChoice.removeAll();

    for(i=0; i < columnCount; i++)
    {
        xChoice.add(columnNames[i]);
        yChoice.add(columnNames[i]);
    }
}


/** Called when an axis variable changes */
protected void variableChange()
{
    xVariable = xChoice.getSelectedItem();
    yVariable = yChoice.getSelectedItem();

    int xColumn = xChoice.getSelectedIndex();
    int yColumn = yChoice.getSelectedIndex();

	int pk;
	String value;

	ad = new double[rowCount];
	ad1 = new double[rowCount];
	pkdata=new Object[rowCount];//object array of primary keys
	piddata = new String[rowCount];

	for(int i = 0; i < rowCount; i++)
	{
		// Hard coded assuming that primary key is first!!!
		pk = findColumn(pkName);
		/************************************************************/
		pkdata[i]=data[i][pk];
		//pkdata[i]=drs.getObject(pk);//array of primary key objects
		piddata[i] = pkdata[i].toString();
		/************************************************************/

		if(xColumn == pk)
			ad[i] = getValue(piddata[i]);
		else
			ad[i] = getValue(data, i, xColumn);

		if(yColumn == pk)
	       ad1[i] = getValue(piddata[i]);
		else
		{
			if(xColumn == yColumn)
			   ad1[i] = ad[i];
			else
				ad1[i] = getValue(data, i, yColumn);
		}
	}
	Splot.setData(ad, ad1, piddata, 2, rowCount);
}

/*******************************************************/
private int findColumn(String pkname)
{
	if (pkname!=null)
	{
		for(int i=0; i<columnCount; i++)
		{
			if (pkname.equals(columnNames[i]))
			{
				return i;
			}
		}
	}
	return 0; // default column
}
/*************************************************************/

/* Returns the double value of a particular column in the ResultSet */
protected double getValue(Object[][] data, int row, int column)
{
	if(data[row][column] == null)
		return 0;
	else
		return getValue(data[row][column].toString());
}

/* This function will take in a String and will parse it into a double
 * as best that it can.  If it is unable, it will return 0.  */
protected double getValue(String number)
{
    String value;
    double answer = 0;
    if(number == null) return 0;

    value = number.replace('%', ' ').trim();
    try // try to parse the numeric format
    {
        answer = Double.parseDouble(value);
    }
    catch(NumberFormatException e)
    {
        if(value.length() == 0)
			answer = 0;
	else
	{
	    try  // try to parse everything before the first space
	    {
	        int space = value.indexOf(" ");
			if (space == -1)
				answer = 0;
			else
				answer = getValue(value.substring(0, space));
	    }
	    catch(Exception ex)
	    {
	        answer = 0;
	    }
	}
    }
    return answer;
}

public void init()
{

    //System.out.println("Scatterplot init()");
    setBackground(Color.white);
    String s = "Income HSGrad";
    String s1 = "0 0";
    String s2 = "Empty";
    getData(s, s1, s2);
    getPlot();
    //System.out.println("Assigning ScatterPlot");
    Splot.assignScatterplot(this);
    setLayout();
}

protected void getData(String s, String s1, String s2)
{
	Vector vector = new Vector();
	Vector vector1 = new Vector();
	Vector vector2 = new Vector();
	String s3;

	StringTokenizer stringtokenizer = new StringTokenizer(s);
	while( stringtokenizer.hasMoreTokens() )
	{
		s3 = new String(stringtokenizer.nextToken());
		vector1.addElement(s3);
	}

	variableCount = vector1.size();
	sdata = new String[variableCount];
	vector1.copyInto(sdata);

	StringTokenizer stringtokenizer1 = new StringTokenizer(s1);
	dataCount = stringtokenizer1.countTokens() / variableCount;
	boolean flag = true;
	for(int i = 0; i < dataCount; i++)
	{
		if(flag)
		{
			for(int j = 0; j < variableCount; j++)
				vector.addElement(new Vector());
			flag = false;
		}
		for(int k = 0; k < variableCount; k++)
		{
			Double double1 = new Double(stringtokenizer1.nextToken());
			((Vector)vector.elementAt(k)).addElement(double1);
		}
	}

	ddata = Transform.V2Dtoa2d(vector, variableCount, dataCount);
	String s4;
	StringTokenizer stringtokenizer2 = new StringTokenizer(s2);
	while(stringtokenizer2.hasMoreTokens())
	{
		s4 = new String(stringtokenizer2.nextToken());
		vector2.addElement(s4);
	}

	piddata = new String[dataCount];
	vector2.copyInto(piddata);
	marked = new boolean[dataCount];
	oldmark = new boolean[dataCount];
	for(int l = 0; l < dataCount; l++)
	{
		marked[l] = false;
		oldmark[l] = false;
	}

}

protected void getPlot()
{
	ad = new double[dataCount];
	ad1 = new double[dataCount];
	pkdata=new Object[dataCount];//object array of primary keys
	for(int i = 0; i < dataCount; i++)
	{
		ad[i] = ddata[0][i];
		ad1[i] = ddata[1][i];
		pkdata[i] = new Double(ad[i]);
	}

	Splot = new PlotCanvas(ad, ad1, piddata, variableCount, dataCount);
	//System.out.println("variableCount = "+variableCount);
	//System.out.println("dataCount = "+dataCount);

	pointid = new Text(piddata);
	xChoice.add("X");
	yChoice.add("Y");
	xVariable = xChoice.getSelectedItem();
	yVariable = yChoice.getSelectedItem();
}

protected void setLayout()
{
	// Added by Nathan to manage applet
	menu.setLayout(new GridLayout(1,2));
	menu.setBackground(Color.white);

	Panel xPanel = new Panel(new BorderLayout());
	xPanel.add(xLabel, BorderLayout.WEST);
	xPanel.add(xChoice, BorderLayout.CENTER);
	menu.add(xPanel);

	Panel yPanel = new Panel(new BorderLayout());
	yPanel.add(yLabel, BorderLayout.WEST);
	yPanel.add(yChoice, BorderLayout.CENTER);
	menu.add(yPanel);

/*
	menu.add(xLabel);
	menu.add(xChoice);
	menu.add(yLabel);
	menu.add(yChoice);
*/

	int gapSize = 20;
	BorderLayout appletLayout = new BorderLayout(gapSize, gapSize);
	BorderLayout canvasLayout = new BorderLayout(gapSize, gapSize);
	BorderLayout controlsLayout = new BorderLayout(gapSize, gapSize);
	
	Panel controlsPanel = new Panel();
	controlsPanel.setLayout(controlsLayout);
	controlsPanel.add(new Button("Reset"), BorderLayout.NORTH);
	controlsPanel.add(pointid, BorderLayout.CENTER);

	//System.out.println("canvasPanel about to be created");
	//System.out.println("setLayout()");
	//System.out.println("add()");

	JPanel canvasPanel = new JPanel();
	canvasPanel.setLayout(new BorderLayout());
	canvasPanel.add(menu, BorderLayout.NORTH);
	canvasPanel.add(Splot, BorderLayout.CENTER);
	
	//System.out.println("Canvas created");
	//setLayout(appletLayout);
	//add(canvasPanel, BorderLayout.CENTER);
	//add(controlsPanel, BorderLayout.EAST);

	getContentPane().add(canvasPanel, BorderLayout.CENTER);

}

public boolean action(Event event, Object obj)
{
	if(obj.equals("Reset"))
	{
		clearPlot();
	}
	return true;
}

/* Test code by Nathan */
public void clearPlot()
{
    Splot.resetPlot();
    pointid.Deletetext();
    for(int i = 0; i < dataCount; i++)
    {
        marked[i] = false;
        pointid.list.deselect(i);
        oldmark[i] = false;
    }
	highlight(marked);
}

/***********************************************************************/

public boolean handleEvent(Event event)
{
    if(event.target == xChoice || event.target == yChoice)
	{
	    if( xChoice.getSelectedItem() != xVariable ||
	        yChoice.getSelectedItem() != yVariable)
                    variableChange();
	    return true;
	}
	if(event.id == 503)
	{
		String s = Splot.getStatus();
		showStatus(s);
		return true;
	}
	if(event.id == 502)
	{
		//String as[] = new String[dataCount];
		marked = Splot.getmarked();
		int j = 0;
		for(int l = 0; l < marked.length; l++)
			if(marked[l] && !oldmark[l])
			{
				//as[j] = piddata[l];
				oldmark[l] = true;
				j++;
			}

		highlight(marked);
		//pointid.addText(marked);
		return true;
	}
	if(event.id == 702)
	{
		for(int i = 0; i < pointid.list.countItems(); i++)
			marked[i] = pointid.list.isSelected(i);

		Splot.marked = marked;
		Splot.DrawImage();
		highlight(marked);
		pointid.addText(marked);
	}
	if(event.id == 701)
	{
		int ai[] = pointid.list.getSelectedIndexes();
		for(int k = 0; k < ai.length; k++)
			marked[ai[k]] = true;

		highlight(marked);
		pointid.addText(marked);
	}
	return super.handleEvent(event);
}

void highlight(boolean aflag[])
{
/****************CODE FOR FIRING SNAP EVENT*************************/
	Vector v = new Vector();
    for(int i = 0; i < aflag.length; i++)
    {
        if(aflag[i])
        {
             v.add(pkdata[i]);
        }
    }
	SnapEvent snapEvent = null;
	if (v.size()==0)
	{
		snapEvent = new SnapEvent(this, SELECT_EVENT_ID, null);
	}    
	else 
	{
		snapEvent = new SnapEvent(this, SELECT_EVENT_ID, v);
	}

	fireSnapEvent(snapEvent);
       
/*********************************ENDS******************************/

    Splot.highlight(aflag);
}


};
