
package snap.adapter;

import snap.*;
import snap.database.Query;

import java.util.*;
import java.sql.*;
import java.net.URL;
import javax.swing.*;

/** Adapter between Snap's general interface to the interface specific
  * for Cave visualizations.
  */
public class CaveMoleculeAdapter extends TechnologyAdapter// implements SnapEventListener
{
//	private Thread t;
	private Snap snap;
	private Snapable visualization;
	private SnapEventListener sel;

/* Set when firing an event at a visualization.  When set, the adapter
ignores events coming back from the visualization.  Allows the adapter to
ignore talkback. */
private boolean ignoreVisualizationEvents;

private final int HANDLE_LOAD = 0;
private final int HANDLE_PERFORMSNAPEVENT = 1;
private final int HANDLE_SNAPEVENTOCCURED = 2;

private final String LOAD_ACTION = "Load";

private Vector loadQueue = new Vector();
private Vector snapEventOccuredQueue = new Vector();
private Vector performSnapEventQueue = new Vector();
private Vector eventSelectionQueue = new Vector();

// In JDBC, each thread should have its own connection
	private Connection connection = null;
//protected Snap snap;

public CaveMoleculeAdapter(Snap snap)
	{
   //	this.visualization = visualization;
	this.snap = snap;
//	visualization.addSnapEventListener(this);
	}

/** Called when Snap needs to load data into the visualization */
public void load(Query query)
	{
	}

/** Called when Snap needs to unload data from the visualization */
public void unload(Query query)
	{
	}

/** Called when Snap needs to fire an event at the visualization */
public void performSnapEvent(SnapEvent e)
	{
	// test event fields for an appropriate id
	snap.getFeedbackPanel().setText("molecule" + e.getKeys().get(0));
	Rmi Test = new Rmi();
	for (int i=0; i< e.getKeys().size(); i++)
	{
		Test.SendMessage("molecule", (String)e.getKeys().get(i));
	}


	}

/** Returns a list of Actions supported by a visualization */
public Enumeration getSupportedActions()
	{
	Vector v = new Vector();
	v.add("Select (receive only)");
	v.add("Unload");
	v.add("Load");
	// do more v.add()
	return v.elements();
	}

/** Returns the component's Icon or tries to find a default Icon */
public Icon getIcon()
	{
	Icon icon = null;
	try
	{
		// Must change
		String base = snap.getCodeBase().toString();
		//String iconURL = base + "snap/1.icon.gif";
		String iconURL = base + "snap/hotjava.icon.gif";
		icon = 	new ImageIcon(new URL(iconURL));
	}
	catch(Exception e)
	{
		System.err.println("CaveTechnologyAdapter " +
			"unable to create an icon: " + e.toString());
		    snap.getFeedbackPanel().setText("Could not do icon :(" + e.toString());

	}
	return icon;
	}

}
