
package snap.graph;

import java.util.EventObject;

/** An event that indicates that the graph has changed.
  *
  * @author Nathan Conklin - nathan@conklinfamily.net
  * @author Chris North - north@cs.vt.edu
  * @author Varun Saini - vsaini@vt.edu
  * @author Umer Farooq - ufarooq@vt.edu
  * @author Aniket Prabhune - aprabhun@vt.edu
  */
public class GraphChangeEvent extends EventObject
{

public static final int NODE_ADDED = 0;
public static final int NODE_REMOVED = 1;

int eventType;
Node node;

public GraphChangeEvent(Object source, int eventType, Node node)
{
    super(source);
    this.eventType = eventType;
    this.node = node;
}

public int getEventType()
{
    return eventType;
}

public Node getNode()
{
    return node;
}


}

