
package snap.graph;

/** The Read Write Monitor Class
  *
  * @author Varun Saini - vsaini@vt.edu
  * @author Umer Farooq - ufarooq@vt.edu
  * @author Nathan Conklin - nathan@conklinfamily.net
  * @author Chris North - north@cs.vt.edu
  */
public class Monitor{

private int readers =0;
private boolean writing = false;

/** While some writer is writing reader waits else number of readers
is incremented */
  public synchronized void acquireRead()
             throws InterruptedException {
    while (writing) wait();
    ++readers;
  }

/** Number of readers is deccremented . If there are no more readers
then one writer is notified */

  public synchronized void releaseRead() {
    --readers;
    if(readers==0) notify();
  }

/** While some writer is writing or some reader is reading writer
waits else writer starts writing */
  public synchronized void acquireWrite()
              throws InterruptedException {
    while (readers>0 || writing) wait();
    writing = true;
  }

/** Writer finishes writing and notify all the waiting threads */
  public synchronized void releaseWrite() {
    writing = false;
    notifyAll();
  }
}

