
package snap.graph;

import snap.database.*;  // for the Query object
import snap.adapter.*; // for the TechnologyAdapter

import java.util.*;
import javax.swing.*; // for Icon stuff
import java.net.*; // for Sample Icon

/** A node in the Graph; the Node contains all of the information for a
  * visualization.  The Node is created by the UI.
  *
  * @author Nathan Conklin - nathan@conklinfamily.net
  * @author Chris North - north@cs.vt.edu
  * @author Varun Saini - vsaini@vt.edu
  * @author Umer Farooq - ufarooq@vt.edu
  * @author Aniket Prabhune - aprabhun@vt.edu
  */
public class UINode extends CoordinationNode
{

// Type of visualization
private String type;
private String description;

public UINode(UIGraph graph, String name, String type, 
	String description, Query query, TechnologyAdapter adapter)
{
	super(graph, name, query, adapter);
    setType(type);
    setDescription(description);
}

/** Sets the visualization type */
public void setType(String type)
{
    this.type = type;
}

/** Returns the visualization type */
public String getType()
{
    return type;
}

public void setDescription(String description)
{
    this.description = description;
}

public String getDescription()
{
    return description;
}

/** Returns the component's Icon from the TechnologyAdapter */
public Icon getIcon()
{
	return getTechnologyAdapter().getIcon();
}

}

