
package snap.loader;

/**
 * Static storage used for communication between applets across frames.  
 * It holds a reference to the coordination manager.
 * <br><br>
 * @author Nathan Conklin - nathan@conklinfamily.net
 * @author Chris North - north@cs.vt.edu
 * @author Tobias Hill - tobias.hill@citerus.se
 * <br><br>
 * This program can be used in any way you like. 
 * The code is however provided "as is" and the author will not be liable 
 * for any damages suffered as a result of your use.  Furthermore, you 
 * understand the source code comes without any technical support.
 * <br><br>
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */
public class StaticMemoryList{

private static Object manager = null;

/** Method for locating the Manager from the StaticMemoryList */
public static synchronized Object getManager()
{
	return manager;
}

/** Method for registering a Manager */
public static void setManager(Object aManager)
{
    manager = aManager;
}


}
