
package snap.ui;

import snap.*;
import snap.database.*;

import netscape.javascript.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/** Handles talking to the frames UI.
  *
  * @author Nathan Conklin - nathan@conklinfamily.net
  * @author Chris North - north@cs.vt.edu
  */
public class FrameManager extends JPanel
implements ConnectionChangeEventListener
{

protected Snap snap;

/** Notifies the FrameManager that the database connection changed. */
public void connectionChanged(ConnectionChangeEvent e)
{
	DatabaseManager databaseManager = (DatabaseManager) e.getSource();
    if(databaseManager.getConnection() != null)
	{
		snap.getFeedbackPanel().setText(
			"Click on links in the right-hand frame to split frames " +
			"and add visualization components");
		// Show the frames
		setFrame("../visualizations.html");
    }
    else
    {
		// Show information to help them connect to a database
		setFrame("../../doc/index.html");
    }
}

/** Constructor for the FrameManager.
  * @param snap a reference to the Snap object **/
public FrameManager(Snap snap)
{
    this.snap = snap;
}


protected void setFrame(String location)
{
	// The "javascript:" protocol is supported only with Netscape browser.
	// To be compatible IE4 and Netscape, it would be a good idea to use
	// the netscape.javascript.* package. (this is left as a "to-do" for
	// the reader!)

	// NS4 parent.visualizations.location.href = "default.asp"
	// IE4 parent.visualizations.location.href = "default.asp"
	// DOM parent.document.getElementById("myLeftFrame").src = "default.asp"

	String frameName = "visualizations";
	String js = "";
	try
	{
		// Note: Must have the MAYSCRIPT option in the html file
		JSObject win = (JSObject) JSObject.getWindow(this.snap);

		js = "parent." + frameName + ".location.href = \"" +
				location + "\";";

		win.eval(js);
	}
	catch(Exception e)
	{
		if (!js.equals(""))
			System.err.println(js);
		String error = "Unable to execute the JavaScript: " + e.toString();
		error += "\nThis currently does not work in Netscape 6";

		snap.getFeedbackPanel().setText(error);
		e.printStackTrace();
	}
}


};
