<?xml version='1.0'?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<!-- npolys for db population
	 XPath node processing got screwy - all or nothing-->
<xsl:output method="text"  indent="no" />

<xsl:template match="/">
compound_parent, atom_id, element_type, units, x3, y3, z3

<xsl:for-each select="//*/atom">

<xsl:choose>
  <xsl:when test=".//float[@builtin='x3']">
  <!--    3D Molecule build                         -->

	<xsl:variable name="elem" select=".//string[@builtin='elementType']"/>
	<xsl:variable name="elemID" select="@id"/>
        <xsl:variable name="pa" select="../@id"/>
	<xsl:variable name="elemX" select=".//float[@builtin='x3']"/>
	<xsl:variable name="elemY" select=".//float[@builtin='y3']"/>
	<xsl:variable name="elemZ" select=".//float[@builtin='z3']"/>
	<xsl:variable name="units" select=".//float/@units"/>

		<xsl:value-of select="$pa"/>,
		<xsl:value-of select="$elemID"/>,
		<xsl:value-of select="$elem"/>,
		<xsl:value-of select="$units"/>,
		<xsl:value-of select="$elemX"/>,
		<xsl:value-of select="$elemY"/>,
		<xsl:value-of select="$elemZ"/>
  </xsl:when> 	<!--     </xsl:when 3D>            -->

 <xsl:otherwise>
	<xsl:variable name="elem" select=".//string[@builtin='elementType']"/>
	<xsl:variable name="elemID" select="@id"/>
	<xsl:variable name="pa" select="../@id"/>
	<xsl:variable name="elemX" select=".//float[@builtin='x2']"/>
	<xsl:variable name="elemY" select=".//float[@builtin='y2']"/>
	<xsl:variable name="elemZ" select="0"/>
	<xsl:variable name="units" select=".//float/@units"/>
		<xsl:value-of select="$pa"/>,
		<xsl:value-of select="$elemID"/>,
		<xsl:value-of select="$elem"/>,
		<xsl:value-of select="$units"/>,
		<xsl:value-of select="$elemX"/>,
		<xsl:value-of select="$elemY"/>,
		<xsl:value-of select="$elemZ"/>
 </xsl:otherwise>
</xsl:choose>
</xsl:for-each>

</xsl:template>





</xsl:stylesheet>
