<?xml version='1.0'?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<!-- npolys for db population
	 XPath node processing got screwy - all or nothing-->

<xsl:output method="text" />

<xsl:template match="/">
  <xsl:apply-templates/>
</xsl:template>

<xsl:template match="//document" name="document">
  <xsl:apply-templates select="cml"/>
</xsl:template>

<xsl:template match="//cml" name="cml">
ID, title, formula, molecule_weight, specific_gravity, melting_point, CAS, ACX, DOT, RTECS
  <xsl:apply-templates select="molecule"/>
</xsl:template>

<xsl:template match="//molecule" name="molecule">

<xsl:value-of select="@id"/>,
<xsl:value-of select="@title"/>,
<xsl:value-of select=".//formula"/>,

 <!--	<xsl:variable name="title" select="@title" />
  	<xsl:variable name="ID" select="@id" />
 	<xsl:variable name="formula" select=".//formula" />       -->

       <xsl:for-each select=".//float">
	<xsl:choose>
	  <xsl:when test=".//float[@title='molecule weight']">
              <xsl:variable name="molw" select="." />
              <xsl:value-of select="$molw"/>,
	  </xsl:when>
	  <xsl:when test=".//float[@title='melting point']">
              <xsl:variable name="mp" select="." />
              <xsl:value-of select="$mp"/>,
	  </xsl:when>
	  <xsl:when test=".//float[@title='specific gravity']">
             <xsl:variable name="sg" select="." />
             <xsl:value-of select="$sg"/>,
	  </xsl:when>

	</xsl:choose>




       </xsl:for-each>


       <xsl:for-each select=".//string">
	<xsl:choose>
	  <xsl:when test=".//string[@title='CAS']">
             <xsl:variable name="cas" select="." />
             <xsl:value-of select="$cas"/>,
	  </xsl:when>
	  <xsl:when test=".//string[@title='ACX']">
             <xsl:variable name="acx" select="." />
             <xsl:value-of select="$acx"/>,
	  </xsl:when>
	  <xsl:when test=".//string[@title='DOT']">
             <xsl:variable name="dot" select="." />
            <xsl:value-of select="$dot"/>
	  </xsl:when>
	  <xsl:when test=".//string[@title='RTECS']">
             <xsl:variable name="rtecs" select="."  />

	<xsl:value-of select="$rtecs"/>
	  </xsl:when>

	</xsl:choose>



       </xsl:for-each>

</xsl:template>


<xsl:template match="molecule/date">
</xsl:template>
<xsl:template match="molecule/list">
</xsl:template>

<xsl:template match="molecule/atomArray">
</xsl:template>
<xsl:template match="molecule/bondArray">
</xsl:template>

<xsl:template match="spectrum/*">
</xsl:template>

<xsl:template match="chimeral/spectrum">
</xsl:template>
<xsl:template match="chimeral/string">
</xsl:template>
<xsl:template match="chimeral/float">
</xsl:template>
<xsl:template match="chimeral/list">
</xsl:template>

</xsl:stylesheet>
