
#include "CommandParser.h"

CommandParser::CommandParser()
{
  CurrCommand = "";
  istr = NULL;
  string ShmName = "";
  Poll = false;
  
  char* charShmName = getenv("DTK_COMMAND_SHM_NAME");
  if(charShmName == NULL) ShmName = "CommandMessage";
  else ShmName = charShmName;

  if(ShmName.length() == 0) ShmName = "CommandMessage";

  Receive = new dtkSharedMem(128*sizeof(char),ShmName.c_str());
  if(!Receive || Receive->isInvalid() || Receive->getSize() < (128*sizeof(char))) {
		printf ("could not get shared mem in CommandParser\n");
	}

  Receive->flush();
  Receive->queue();
}
CommandParser::CommandParser(const int& Flag)
{
  CurrCommand = "";
  istr = NULL;
  string ShmName = "";
  Poll = false;
  if (Flag == 1)
	  Poll = true;
  char* charShmName = getenv("DTK_COMMAND_SHM_NAME");
  if(charShmName == NULL) ShmName = "CommandMessage";
  else ShmName = charShmName;

  if(ShmName.length() == 0) ShmName = "CommandMessage";

  Receive = new dtkSharedMem(128*sizeof(char),ShmName.c_str());
  if(!Receive || Receive->isInvalid() || Receive->getSize() < (128*sizeof(char))) {
		printf ("could not get shared mem in CommandParser\n");
	}

  Receive->flush();
//  Receive->queue();
}
CommandParser::CommandParser(char* Filename)
{
  CurrCommand = "";
  istr = NULL;
  string ShmName = "";
  Poll = false;
  if(Filename == NULL) ShmName = "CommandMessage";
  else ShmName = string(Filename);

  if(ShmName.length() == 0) ShmName = "CommandMessage";

  Receive = new dtkSharedMem(128*sizeof(char),ShmName.c_str());
  if(!Receive || Receive->isInvalid() || Receive->getSize() < (128*sizeof(char))) {
		printf ("could not get shared mem in CommandParser\n");
	}

  Receive->flush();
  Receive->queue();
}


CommandParser::~CommandParser()
{
  delete istr;
  istr = NULL;
}

int CommandParser::getCommand(string& Command, string targetClass)
{
	if (!Poll)
		  if(!Receive->qread(buff)) return 1;
	if (Poll)
		if(!Receive->read(buff)) return 1;
  
  if(istr != NULL){
    delete istr;
    istr = NULL;
  }
  
  string newCommand = buff;
  Command = "BOGUS";
  istr = new istringstream(newCommand);
  string classname;
  *istr>>classname;
  if(classname == "NONE" || classname == targetClass){
    *istr>>Command;
  }

  return 0;
}

int CommandParser::getInt()
{
  int nextInt=-1;
  *istr>>nextInt;
  return nextInt;
}

string CommandParser::getString()
{
  string nextString = "BOGUS";
  *istr>>nextString;
  return nextString;
}

double CommandParser::getDouble()
{
  double nextD = -1;
  *istr>>nextD;
  return nextD;
}

char CommandParser::getChar()
{
  char nextChar = '';
  *istr>>nextChar;
  return nextChar;
}
