#ifndef _FAKE_MOUSE_H_
#define _FAKE_MOUSE_H_

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <X11/Xlib.h>
#include <X11/Xlib.h>
#include <X11/extensions/XTest.h>
#include <X11/extensions/XInput.h>
#include <X11/keysym.h>

enum {
  FM_BUTTON1,
  FM_BUTTON2,
  FM_BUTTON3,
  FM_RAISE_WINDOW,
  FM_LOWER_WINDOW,
  FM_MOVE_WINDOW,
  FM_RESIZE_WINDOW,
  FM_MAXIMIZE_WINDOW,
  FM_MINIMIZE_WINDOW,
  FM_RESTORE_WINDOW,
  FM_DESTROY_WINDOW,
  FM_KEYPRESS,
  FM_SYSTEM
};

class FakeMouse {
 public:
  FakeMouse(char *disp=NULL);
  ~FakeMouse();

  void doEvent(int event, int change, char* command);
  void keyPress(int status, int keysym);
  
  void update();
  void Press(int b);
  void Release(int b);
  void Click(int b);
  void DoubleClick(int b);

  void RaiseWindow();
  void LowerWindow();
  void StartMoveWindow();
  void StopMoveWindow();
  void StartDrawLine();
  void StopDrawLine();
  void StartResizeWindow();
  void StopResizeWindow();
  void DestroyWindow();
  void MinimizeWindow();
  void MaximizeWindow();
  void RestoreWindow();

  void SetPosition(int x, int y);
  void AddPosition(int x, int y);

  int* getMousePosition();
  Display* GetDisplay(){return dpy;};
  void get_pointer_position();

 private:
  static void xtestext1_correct_mouse(Display *dpy);
  void XW_send_fake_Xbutton(Display *dpy, int button, Bool press);


  Display *dpy;
  Window root;
  Window current_wnd;
  XWindowAttributes attrib;
  int real_x, real_y, last_x, last_y, wnd_x, wnd_y;
  unsigned int mask;

  int moving_wnd, resizing_wnd, drawing_line;
};

#endif

