///////////// CommandParser.h //////////////////////
//  Used to parse commands, or messages.
////////////////////////////////////////////////////
//By Mark J. Soltys II, modified by Andrew A. Ray
//


#ifndef COMMANDPARSER_H
#define COMMANDPARSER_H

#include <string>
#include <sstream>
#include <iostream>
#include <dtk.h>

using namespace std;

class CommandParser
{
  private:
    string CurrCommand;
    istringstream* istr;
    char buff[128];
    dtkSharedMem* Receive;
    bool Poll;

  public:
    CommandParser();
    CommandParser(const int& Flag, char* Filename);
    CommandParser(const int& Flag);
    CommandParser(char* Filename);
    ~CommandParser();
    
    int getCommand(string& Command, string TargetClass);
    int getCommandLine(string& Command, string targetClass);

    int getInt();
    string getString();
    double getDouble();
    char getChar();
    
};
#endif
