#include "Messenger.h"

Messenger::Messenger()
{
  // New Message Stuff.

  string ShmName = "";
  char* charShmName = getenv("DTK_COMMAND_SHM_NAME");
  if(charShmName == NULL) ShmName = "CommandMessage";
  else ShmName = charShmName;
  
  if(ShmName.length() == 0) ShmName = "CommandMessage";
  
  Send = new dtkSharedMem (128 * sizeof(char), ShmName.c_str());
  //if(!Send || Send->isInvalid() || Send->getSize() < (128*sizeof(char))){
   // cout<<"could not get shared mem for Messenger"<<endl;
  //}

  // End Message Stuff
}
Messenger::Messenger(char* Filename)
{
  // New Message Stuff.

  string ShmName = "";
  if(Filename == NULL) ShmName = "CommandMessage";
  else ShmName = string(Filename);

  if(ShmName.length() == 0) ShmName = "CommandMessage";

  Send = new dtkSharedMem (128 * sizeof(char), ShmName.c_str());
}

Messenger::~Messenger()
{
  delete Send;
}

//////////////////////////////////////////////////////////////////////////
//  Function: SendCommand
//
//  Purpose:  Writes to shared memory a string in the following format.
//            _______________ <tab> ______________ <tab> ______________ 
//            target class name     actual command       any parameters
//
//            and then the string is terminated with a null char. "\0"
//
//  Parameters:  A string (command) that will be passed into shared memory.
//
//  Returns: An integer according to how it executed.
//
//////////////////////////////////////////////////////////////////////////

int Messenger::SendCommand(string Command)
{
  string NONE = "NONE";
  string pass = NONE + "\t" + Command + "\0";
  Send->write(pass.c_str(),(pass.length()+1)*sizeof(char));
  return 0;
}

int Messenger::SendCommand(string Command, string targetClass)
{
  string pass = targetClass + "\t" + Command + "\0";
  Send->write(pass.c_str(),(pass.length()+1)*sizeof(char));
  return 0;
}
