#ifndef sharedatoms_h
#define sharedatoms_h


//This class basically is used as a wrapper for incrementing, decrementing, and going to a basic data set
//It uses the original Atomview's file parser and data structure(FlexArray and TimeAtomList) to handle the
//backend data handling (this allows for interpolation of data though it is not recommended).
//
//Reasoning behind the reuse of code == If it works, then don't re-invent the wheel
//The reason for this is that I can easily change out how I get the atoms out of the program
//without changing a lot of code.  You can write your own parser and put it here if you want
class DTKSharedAtoms
{
	public:
	//Create with the filename to write to, the base file name (fort) starting index(31) and ending index(45) and the list of atoms
	//to write the data to
	DTKSharedAtoms(char* SharedMemFileName, FlexArray<AtomDef>& TheAtoms, FlexArray<BondDef>& TheBonds, bool& Change);
	//Destroy the information
	~DTKSharedAtoms();
	//Go forward one data set
	void GoForward() { if ((int)(Index + 1) <= (int)Finish) Index++;};
	//Go back one data set
	void GoBackward() { if ((int)(Index -1) > (int)Begin ) Index--;};
	//Return the first position
	int Start() { return (int)Begin;};
	//Return the last position
	int End() { return (int)Finish;};
	//Return the current position
	float Curr() {return Index;};
	//Goto a specific position
	void Goto(const float& Position){ if((int)Index > -1 && Index <=(int)Finish) Index = Position;};
	//Write the current data to TheAtoms (this program originally stored the atoms in a dtkSharedMem
	//object, but this had to be abandoned due to the nature of large data sets and dtkSharedMem's
	//problem with these.
	/*int WriteToSharedMem();*/
	//Write at a specific time to  TheAtoms
	void GetAtoms(string Molecule);
	int WriteToSharedMem(string Molecule);
	bool readStuff;
	//It is necessary to get the color information out of the data
	//This is the atom data set manager from the original atomview
	MoleculeList* FileData;
	private:
	bool* Changed;
	//The data that FileData writes to 
	FlexArray<AtomDef> *Data;
	FlexArray<BondDef> *BondData;
	//Current position
	float Index;
	//Beginning position
	float Begin;
	//Ending position
	float Finish;
};
#endif
