#include <unistd.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <dpf.h>
#include <dtk.h>
#include <Performer/pf.h>
#include <Performer/pr.h>
#include <Performer/pf/pfGeode.h>
#include <Performer/pr/pfMaterial.h>
#include <string>
using namespace std;
#include "FlexArrayTmpl.H"
#include "ReadAtomFiles.hh"
#include "SharedAtoms.h"
#include "CommandParser.h"
#include "Messenger.h"
#include "AtomCommands.h"
#include "colorhandler.h"
#include "atomview.h"
float AtomView::getCurrentTrans(int Cur){
	int numMolecules = MolDArray.getSize();
	int numInFront = 0;
	//printf("Current order=%i\n",MolDArray[Cur].Order);
	//printf("Current MolDArraySize %u, CurID %u\n", numMolecules, Cur);
	//if (numMolecules == 1 || ! AtomList->FileData->molecules[Cur].Visible)
	
	if (MolDArray[Cur].Order == 1)
	{
		return 0;
	}
	//printf("Current MolDArraySize %u, CurID %u", numMolecules, Cur);
	pfSphere tempSphere;
	//bool first=true;
	float totaltrans=0;
	for (int i=0; i < numMolecules; i++){
		if (AtomList->FileData->molecules[i].Visible){
			//printf("Got in here somehow");
			MolDArray[i].MolScaler->getBound(&tempSphere);
			if (MolDArray[i].Order == 1)
			{
				totaltrans += tempSphere.radius + tempSphere.center[0];
				numInFront++;
			}
			else if (i==Cur)
			totaltrans += tempSphere.radius - MolDArray[Cur].center[0];
			else if (MolDArray[i].Order < MolDArray[Cur].Order || MolDArray[Cur].Order==-1)
			{
				totaltrans += 2*tempSphere.radius;
				numInFront++;
			}
			/*if (first && i==Cur)
				return 0;
			else if (first)
			totaltrans += tempSphere.radius + tempSphere.center[0];
			else if (i==Cur)
			totaltrans += tempSphere.radius - MolDArray[Cur].center[0];
			else
			totaltrans += 2*tempSphere.radius;
			*/
			totaltrans += 1;
			//first = false;
		}
	}
	if (MolDArray[Cur].Order==-1)
		MolDArray[Cur].Order = numInFront + 1;
	if (numInFront == 0)
	{
		MolDArray[Cur].Order = 1;
		totaltrans = 0;
	}
	return totaltrans;
}


void AtomView::CheckPosition(){
	int numMolecules = MolDArray.getSize();
	float deltax, deltay, deltaz;
	float distfromcenter;
	//printf("Current MolDArraySize %u, CurID %u", numMolecules, Cur);
	pfSphere tempSphere;
	for (int i=0; i < numMolecules; i++){
		if (AtomList->FileData->molecules[i].Visible && i!=PreviousID){
			//printf("Got in here somehow");
			MolDArray[i].MolScaler->getBound(&tempSphere);
			deltax = tempSphere.center[0]- curpos[0];
			deltay = tempSphere.center[1]- curpos[1];
			deltaz = tempSphere.center[2]- curpos[2];
			distfromcenter = sqrt(deltax*deltax + deltay*deltay + deltaz*deltaz);

			if (distfromcenter < tempSphere.radius)
			{
				//printf("tempSphere center=%f,%f,%f\n", tempSphere.center[0],tempSphere.center[1],tempSphere.center[2]);
				//printf("curpos=%f,%f,%f\n", curpos[0], curpos[1], curpos[2]);
				//printf("Delta=%f,%f,%f\n", deltax, deltay, deltaz);
				//printf("%f,%f\n", distfromcenter, tempSphere.radius);
				Messenger textMessage("HEADSUP_MESSAGE");
				textMessage.SendCommand("clear");
				int numtextline = AtomList->FileData->molecules[i].textinfo.getSize();
				//printf("%%%%%%%%%%%%%Numtextlines %u,", numtextline);
				for (int j =0; j<numtextline; j++){
					//printf("%s\n",AtomList->FileData->molecules[i].textinfo[j].c_str());
					textMessage.SendCommand(AtomList->FileData->molecules[i].textinfo[j]);
				}
				int NumTypes = AtomList->FileData->molecules[i].atom_types.nTypes();
				//printf("NumTypes= %u", NumTypes);
				for (int j=0; j< NumTypes; j++)
				{
					string tempName = MolDArray[i].CMap[j].Name;
					string tempColor = MolDArray[i].CMap[j].Color;
					string colormessage = "color\t" + tempName + "\t" + tempColor;
					textMessage.SendCommand(colormessage);
				}
				PreviousID = i;
				//printf("*%u*",PreviousID);
				return;
			}

		}
	}
}
