
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <stdio.h>
//This cleans up dtk's shared memory and clears the semaphores from the system
int main(int argc, char* argv[], char** env)
{	
	//Extern variable provided by unistd.h
	char** environ; 
	//Set the environmental variables for 
	//execvp to those that were passed into the
	environ = env;  
			
	//Used to send the id of the child to the parent//program
	//so that the parent can wait on the child to finish
	int Pipe[2]; 
	
	
	//Create the pipe
	pipe(Pipe);

	//Fork off a process
	int cleanpid= fork();
	//Child that destroys shared memory
	if (cleanpid == 0)
	{
		//Get my pid
		int ID = getpid(); 
		//Send it to the parent
		write(Pipe[1], &ID, sizeof(int)); 
		//Setup arguments for an execvp
		char* Cleanup[3];
		Cleanup[0]="dtk-destroySharedMem";
		Cleanup[1]="-r";
		Cleanup[2]=NULL;
		execvp(Cleanup[0], Cleanup);
	}
	else
	{
		//The id of the child
		int ID = -1;
		//Determine which process to wait on
		read(Pipe[0], &ID, sizeof(int));
		//Wait for shared memory to be destroyed first
		wait(&ID);
		//Delete semaphores left over by performer
		//by performing an exec
		char* Cleanup2[2];
		Cleanup2[0]="rmsem.sh";
		Cleanup2[1]=NULL;
		execve(Cleanup2[0], Cleanup2, env);
	}
}
