#include <Performer/pfdu.h>
#include <Performer/pf/pfGeode.h>
#include <Performer/pr/pfGeoSet.h>
#include <Performer/pr/pfMaterial.h>
#include <Performer/pr/pfHighlight.h>
//Figure out which ones I do not need later :P
#include <string.h>
#include "colorhandler.h"

//Create a class instance w/ 7 colors in it!
ColorHandler::ColorHandler(const int& NumPolygons)
{
	//|PFTR_NO_OCCLUDE
	pfTransparency(PFTR_HIGH_QUALITY|PFTR_NO_OCCLUDE);
	pfAlphaFunc(0.01f, PFAF_GEQUAL);
	pfOverride(PFSTATE_TRANSPARENCY|PFSTATE_ALPHAFUNC,PF_ON);

	//This is fixed so we create the 7 necessary colors for use in atomview :)
	NumColors = 16;
	//Create the 7 geodes
	TheGeodes = new pfGeode*[NumColors];
	//Allocate memory for them
	for (int i=0; i<NumColors; i++)
		TheGeodes[i] = new pfGeode();

	//Make the geo state
	TheGState = new pfGeoState;
	//Make a pfMaterial object and set its attributes
	TheMaterial = new pfMaterial;
	TheMaterial->setShininess(100.0);
	TheMaterial->setColorMode(PFMTL_BOTH,PFMTL_CMODE_AMBIENT_AND_DIFFUSE);
	//Set the geo states attributes to include the material
	TheGState->setAttr(PFSTATE_FRONTMTL, TheMaterial);

	//Create the geo sets
	TheGeoSets = new pfGeoSet*[NumColors];
	//Allocate memory for them
	int j;
	for (j=0; j<NumColors/2-1; j++)
		TheGeoSets[j] = pfdNewSphere(NumPolygons, pfGetSharedArena()); //Sphere

	TheGeoSets[j] = pfdNewCylinder(NumPolygons, pfGetSharedArena());

	for (j++; j<NumColors-1; j++)
		TheGeoSets[j] = pfdNewSphere(NumPolygons, pfGetSharedArena()); //Sphere

	TheGeoSets[j] = pfdNewCylinder(NumPolygons, pfGetSharedArena());

	//TheGeoSets[9] = pfdNewCylinder(NumPolygons, pfGetSharedArena());


	//Create the colors
	TheColors = new pfVec4*[NumColors/2];
	pfVec4 clear;
	//Set the color information
	for (int i=0; i<NumColors/2; i++)
		TheColors[i] = new pfVec4;

	//Create the names for all of the colors
	TheNames= new char*[NumColors];
	//Allocate memory for the names (if you use more than 50 chars to describe a color you deserve to be shot)
	for (int i=0; i<NumColors; i++)
		TheNames[i] = new char[50];

	//Associate names with the colors
	strcpy(TheNames[0], "blue");
	strcpy(TheNames[1], "red");
	strcpy(TheNames[2], "green");
	strcpy(TheNames[3], "yellow");
	strcpy(TheNames[4], "orange");
	strcpy(TheNames[5], "white");
	strcpy(TheNames[6], "purple");
	//strcpy(TheNames[7], "highlightcolor");
	strcpy(TheNames[7], "bondcolor");
	strcpy(TheNames[8], "bluemesh");
	strcpy(TheNames[9], "redmesh");
	strcpy(TheNames[10], "greenmesh");
	strcpy(TheNames[11], "yellowmesh");
	strcpy(TheNames[12], "orangemesh");
	strcpy(TheNames[13], "whitemesh");
	strcpy(TheNames[14], "purplemesh");
	strcpy(TheNames[15], "bondcolormesh");
	//strcpy(TheNames[9], "highlightbond");
	//Set their rgb values
	//Blue
	float alpha = .50;
	TheColors[0]->set(0.0, 0.0, 1.0, alpha);
	//Red
	TheColors[1]->set(1,0,0,alpha);
	//Green
	TheColors[2]->set(0, 1, 0, alpha);
	//Yellow
	TheColors[3]->set(1, 1, 0, alpha);
	//Orange
	TheColors[4]->set(1, .5, 0, alpha);
	//White
	TheColors[5]->set( 1,1,1,alpha);
	//Purple
	TheColors[6]->set(0.6275 ,  0.1255  , 0.9412,alpha);
	//TheColors[7]->set(1, 1, 0, .25);
	TheColors[7]->set(1,0,0,1);
	clear.set(0,0,0,0);
	//TheColors[9]->set(1, 1, 0, .4);
	/*pfVec3 * verts = new pfVec3;
	verts->set(1,1,1);*/
	int alpha2 = 1;
 	pfMatrix matrix;
	hLight = new pfHighlight*[8];
	for (int k=0; k <8 ; k++){
		hLight[k]=new pfHighlight;
	}
	printf("%s, %u shitfuck\n", __FILE__, __LINE__);
    	hLight[0]->setColor(PFHL_BGCOLOR, 0.5, 0.5, 0.5);
	hLight[0]->setColor(PFHL_FGCOLOR, 0.0, 0.0, 1.0);
    	hLight[0]->setAlpha(alpha2);
	hLight[0]->setMode(PFHL_LINES);
	hLight[1]->setColor(PFHL_BGCOLOR, 0.5, 0.5, 0.5);
	hLight[1]->setColor(PFHL_FGCOLOR, 1.0, 0.0, 0.0);
    	hLight[1]->setAlpha(alpha2);
	hLight[1]->setMode(PFHL_LINES);
	hLight[2]->setColor(PFHL_BGCOLOR, 0.5, 0.5, 0.5);
	hLight[2]->setColor(PFHL_FGCOLOR, 0.0, 1.0, 0.0);
    	hLight[2]->setAlpha(alpha2);
	hLight[2]->setMode(PFHL_LINES);
	hLight[3]->setColor(PFHL_BGCOLOR, 0.5, 0.5, 0.5);
	hLight[3]->setColor(PFHL_FGCOLOR, 1.0, 1.0, 0.0);
	hLight[3]->setAlpha(alpha2);
    	hLight[3]->setMode(PFHL_LINES);
	hLight[4]->setColor(PFHL_BGCOLOR, 0.5, 0.5, 0.5);
	hLight[4]->setColor(PFHL_FGCOLOR, 1.0, 0.5, 0.0);
	hLight[4]->setAlpha(alpha2);
    	hLight[4]->setMode(PFHL_LINES);
	hLight[5]->setColor(PFHL_BGCOLOR, 0.5, 0.5, 0.5);
	hLight[5]->setColor(PFHL_FGCOLOR, 1.0, 1.0, 1.0);
    	hLight[5]->setAlpha(alpha2);
	hLight[5]->setMode(PFHL_LINES);
	hLight[6]->setColor(PFHL_BGCOLOR, 0.5, 0.5, 0.5);
	hLight[6]->setColor(PFHL_FGCOLOR, .6275, 0.1255, 0.9412);
    	hLight[6]->setAlpha(alpha2);
	hLight[6]->setMode(PFHL_LINES);
	hLight[7]->setColor(PFHL_BGCOLOR, 0.5, 0.5, 0.5);
	hLight[7]->setColor(PFHL_FGCOLOR, 1.0, 0.0, 1.0);
	hLight[7]->setAlpha(alpha2);
    	hLight[7]->setMode(PFHL_LINES);
	for (int i=0; i<NumColors/2; i++)
	hLight[i]->setGState(TheGState);
 	//matrix.makeScale(2,2,8);
	//TheGState->setAttr(PFSTATE_HIGHLIGHT,&hLight);
	//Add the colors to the geosets
	for (j=0; j<NumColors/2; j++){
		TheGeoSets[j]->setAttr(PFGS_COLOR4, PFGS_OVERALL, TheColors[j], NULL);
		//TheGeoSets[j]->setHlight(hLight);
	}
	for (j=j; j<NumColors; j++){
		printf("Highlight colors:%u", j);
		TheGeoSets[j]->setAttr(PFGS_COLOR4, PFGS_OVERALL, &clear, NULL);
		TheGeoSets[j]->setHlight((hLight[j-8]));
	}
	//pfdXformGSet(TheGeoSets[7],matrix);
	//pfdXformGSet(TheGeoSets[15],matrix);
	//matrix.makeScale(2,2,2);
	//pfdXformGSet(TheGeoSets[7],matrix);
	//matrix.makeScale(3,3,1);
	//pfdXformGSet(TheGeoSets[9],matrix);
	//Add the lighting to the geoset
	for (int i=0; i<NumColors; i++)
		TheGeoSets[i]->setGState(TheGState);
	//Add the geoset to the geode
	for (int i=0; i<NumColors; i++)
		TheGeodes[i]->addGSet(TheGeoSets[i]);
}
//Clean up all of the memory this thing allocates
ColorHandler::~ColorHandler()
{
	for (int i=0; i<NumColors; i++)
	{
		delete TheGeodes[i];
		delete TheGeoSets[i];
		delete TheNames[i];
		delete TheColors[i];
	}
	delete TheGeodes;
	delete TheGeoSets;
	delete TheNames;
	delete TheGState;
	delete TheMaterial;
	delete TheColors;
}

//Get a color out of this thing
pfGeode* ColorHandler::GetColor(const char* Color)
{	//printf("The Color=%s", Color);
	//Safety check
	if (Color == NULL)
		return NULL;
	//Loop through the colors and return the proper geode if everything works
	for (int i=0; i<NumColors; i++)
	{
		if (!strcmp(Color, TheNames[i]))
			return TheGeodes[i];
	}
	return NULL;
}

void ColorHandler::AddColor(const char* const Name, const double& r, const double& b, const double& g)
{
	printf("Will be implemented later if needed\n");
	return;
}
